exercises/os-and-networks/webapp/picture/models.py
from webapp.model import db
from datetime import datetime


class Picture(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String, nullable=False)
    url = db.Column(db.String, unique=True, nullable=False)
    date_create = db.Column(db.DateTime, default=datetime.utcnow)
    user_id = db.Column(db.Integer(), db.ForeignKey('user.id', ondelete='CASCADE'), index=True)
    comments = db.relationship('Comment', backref='picture')

    def __repr__(self):
        return '<Pictures {} {}>'.format(self.name, self.url)

exercises/os-and-networks/webapp/picture/forms.py
from flask_wtf import FlaskForm
from wtforms import SubmitField, StringField
from wtforms.validators import DataRequired


class PicturesForm(FlaskForm):
    name = StringField('Название изображения', validators=[DataRequired()], render_kw={"class": "form-control"})
    submit = SubmitField('Загрузить', render_kw={"class": "btn btn-primary"})


class Picture_addForm(FlaskForm):
    name = StringField('Название изображения', validators=[DataRequired()], render_kw={"class": "form-control"})
    submit = SubmitField('Загрузить', render_kw={"class": "btn btn-primary"})

exercises/os-and-networks/webapp/comment/views.py
from flask import Blueprint, render_template, request, redirect, url_for, flash
from flask_login import current_user
from webapp.comment.forms import CommentAddForm
from webapp.comment.models import Comment
from webapp import db
from datetime import datetime

blueprint = Blueprint('comment', __name__, url_prefix='/comment')


@blueprint.route('/')
@blueprint.route('/<int:id_picture>', methods=['GET', 'POST'])
def comment_add(id_picture):
    title = 'Comment_add'
    if current_user.is_authenticated:
        comment_form = CommentAddForm()
        return render_template('comment/comment_add.html', id_picture=id_picture, title=title, form=comment_form)
    return redirect(url_for('user.login'))


@blueprint.route('/process_comment_add/')
@blueprint.route('/process_comment_add/<id_picture>', methods=['GET', 'POST'])
def process_comment_add(id_picture):
    form = CommentAddForm()
    if current_user.is_authenticated:
        picture_id = id_picture
        # comment = form.comment.data
        comment = 'Пока не работает ;)'
        new_comment = Comment(picture_id=picture_id, comment=comment)
        db.session.add(new_comment)
        db.session.commit()
        flash('Комментарий успешно добавлен.')
        return redirect(url_for('picture.pictures'))
    else:
        flash('Вы не авторизованы. Пожалуйста залогиньтесь.')
        return redirect(url_for('user.login'))

exercises/os-and-networks/webapp/picture/views.py
from flask import Blueprint, render_template, url_for, flash, redirect, request
from webapp import db
from webapp.picture.models import Picture
from webapp.comment.models import Comment
from webapp.picture.forms import PicturesForm
from webapp.comment.forms import CommentAddForm
from flask_login import current_user
import os

blueprint = Blueprint('picture', __name__, url_prefix='/picture')


@blueprint.route('/', methods=['GET', 'POST'])
def pictures():
    if current_user.is_authenticated:
        title = "Pictures"
        form = Picture.query.filter(Picture.user_id == current_user.id)
        comment_form = Comment.query.filter(Comment.picture_id == Picture.id)
        return render_template('picture/picture.html', page_title=title, form=form, comment_form=comment_form)
    else:
        flash('Вы не вошли как пользователь. Пожалуйста залогиньтесь.', 'warning')
        return redirect(url_for('user.login'))


@blueprint.route('/picture_add', methods=['GET', 'POST'])
def picture_add():
    if current_user.is_authenticated:
        title = "Picture_add"
        form = PicturesForm()
        if form.validate_on_submit():
            if form.picture.data:
                picture_file = save_picture(form.picture.data)
                current_user.image_file = picture_file
            current_user.username = form.username.data
            current_user.user_email = form.user_email.data
            db.session.commit()
            flash('Your profile has been updated', 'success')
            return redirect(url_for('picture.pictures'))
        elif request.method == 'GET':
            form.username.data = current_user.username
            form.user_email.data = current_user.user_email
        image_file = url_for('static', filename='profile_pics/' + current_user.picture)
        return render_template('picture/picture_add.html', page_title=title, image_file=image_file, form=form)
    else:
        flash('Вы не вошли как пользователь. Пожалуйста залогиньтесь.', 'warning')
        return redirect(url_for('user.login'))


@blueprint.route('/load_picture', methods=['GET', 'POST'])
def load_picture(file_name):
    if request.method == 'POST':
        f = request.files['the_file']
        f.save('/var/www/uploads/uploaded_file.txt')
        directory_project = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
        name = file_name.split('.')[0]
        url = directory_project + '/static/' + file_name
        file_exist = Picture.query.filter(Picture.url == url).count()
        if not file_exist:
            new_picture = Picture(name=name, url=url)
            db.session.add(new_picture)
            db.session.commit()

exercises/os-and-networks/webapp/templates/picture/picture.html
<!DOCTYPE html>
<html lang="en">
{% extends "base.html" %}
<head>
    <meta charset="UTF-8">
    <title>{{ title }}</title>
</head>
<body>
{% block content %}
<div class="container">
    <div class="row">
        <div class="col-1"></div>
        <div class="col-10">
            <p class="text-secondary">
                <h4>Пользователь: {{ current_user.username }}</h4>
            </p>
            <p class="text-secondary">
                <h4>Мои изображения.</h4>
            </p>
            <a class="btn btn-success" href="picture_add" role="button">Добавить изображение</a>
            <br>
            <br>
            <br>
            {% for picture in form %}
            <div class="row">
                <div class="col-8">
                <figure class="figure">
                  <img src="{{ picture.url }}" class="figure-img img-fluid rounded" alt="Ошибка загрузки изображения {{ picture.url }}.">
                  <figcaption class="figure-caption">Название: {{ picture.name }}<br>
                      Дата: {{ picture.date_create }}<br>
                  </figcaption>
                </figure>
                <br>
                <a class="btn btn-info" href="{{ url_for('comment.comment_add') }}/{{ picture.id }}" role="button">Добавить комментарий</a>
                <br>
                <br>
                </div>
                <div class="col-4">
                    <div class="overflow-auto">
                        Комментарии:<br>
                        {% for comment in picture.comments %}
                            <br>
                            {{ comment.date_create }}<br>
                            {{ comment.comment }}<br>
                        {% endfor %}
                    </div>
                </div>
            </div>
            {% endfor %}
        </div>
        <div class="col-1"></div>
    </div>
</div>
{% endblock %}
</body>
</html>

exercises/os-and-networks/webapp/templates/picture/picture_add.html
<!DOCTYPE html>
<html lang="en">
{% extends "base.html" %}
<head>
    <meta charset="UTF-8">
    <title>{{ page_title }}</title>
</head>
<body>
{% block content %}
    enctype="multipart/form-data"
    <form action="{{ url_for('picture.picture_add') }}" method="post">
        <dl class="row">
            <div class="col-1"></div>
            <div class="col-2">
                <div class="form-group">
                    {{ form.name.label }}<br>
                    {{ form.name() }}
                </div>
            </div>
            <dl class="col-3">
                <div class="form-group">
                    <label for="exampleFormControlFile1">Файл изображения</label>
                    <input type="file" class="form-control-file" id="exampleFormControlFile1">
                </div>
            <div class="col-2"></div>
        </dl>
        <div class="row-1">
            <div class="col-1"></div>
            <div class="col-1">{{ form.submit }}</div>
            <div class="col-1"></div>
        </div>
        <div class="row-1">
            Мои изображения:
        </div>
    </form>
{% endblock %}
</body>
</html>